import { ArgumentOutOfRangeException } from "../../shared/index.js";
import { BasicEnumerable } from "../BasicEnumerable.js";
export const range = (start, count) => {
    if (start < 0 || (start + count - 1) > Number.MAX_SAFE_INTEGER) {
        throw new ArgumentOutOfRangeException("start");
    }
    function* iterator() {
        const max = start + count;
        for (let i = start; i < max; i++) {
            yield i;
        }
    }
    return new BasicEnumerable(iterator);
};
