import { IAsyncEnumerable, IAsyncFlatten } from "../../types/index.js";
declare type FlattenAsyncFunc = {
    /**
     * Flattens an async iterable
     * @param source AsyncIterable to flatten
     * @param shallow When false - recurses the iterable types
     */
    <TSource>(source: IAsyncFlatten<TSource>, shallow?: false): IAsyncEnumerable<TSource>;
    /**
     * Flattens an async iterable
     * @param source AsyncIterable to flatten
     * @param shallow When false - recurses the iterable types
     */
    <TSource>(source: IAsyncFlatten<TSource>, shallow: true): IAsyncEnumerable<TSource | AsyncIterable<TSource>>;
};
export declare const flattenAsync: FlattenAsyncFunc;
export {};
