import { IParallelEnumerable, IParallelFlatten } from "../../types/index.js";
declare type FlatternParallelFunc = {
    /**
     * Flattens a parallel iterable
     * @param source IParallelFlatten to flatten
     * @param shallow When false - recurses the iterable types
     */
    <TSource>(source: IParallelFlatten<TSource>, shallow?: false): IParallelEnumerable<TSource>;
    /**
     * Flattens a parallel iterable
     * @param source IParallelFlatten to flatten
     * @param shallow When false - recurses the iterable types
     */
    <TSource>(source: IParallelFlatten<TSource>, shallow: true): IParallelEnumerable<TSource | AsyncIterable<TSource>>;
};
export declare const flattenParallel: FlatternParallelFunc;
export {};
